package br.com.post.util;

import com.google.inject.Guice;
import com.google.inject.Injector;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author otavio
 */
public class AbstractInjection {
     private static Injector injector;
    
    static{
     injector   =   Guice.createInjector(new ServiceModule());
    }
   
    {
        verificarCampos();
        verificarMetodos();
    }
    private void verificarCampos(){
    
        for (Field field : this.getClass().getDeclaredFields()) {
            if (field.getAnnotation(com.google.inject.Inject.class) != null || field.getAnnotation(javax.inject.Inject.class) != null) {
                try {



                    boolean naoAcessivel = true;
                    if (naoAcessivel = !field.isAccessible()) {

                        field.setAccessible(true);
                    }
                    field.set(this, injector.getInstance(field.getType()));
                    if (naoAcessivel) {
                        field.setAccessible(false);
                    }
                } catch (Exception ex) {
                    Logger.getLogger(AbstractInjection.class.getName()).log(Level.SEVERE, null, ex);
                } 

            }
        }
    }
    
    private void verificarMetodos(){
    
        for (Method field : this.getClass().getDeclaredMethods()) {
            if (field.getAnnotation(com.google.inject.Inject.class) != null || field.getAnnotation(javax.inject.Inject.class) != null) {
                try {



                    boolean naoAcessivel = true;
                    if (naoAcessivel = !field.isAccessible()) {

                        field.setAccessible(true);
                    }
                    field.invoke(this);
                    if (naoAcessivel) {
                        field.setAccessible(false);
                    }
                } catch (Exception ex) {
                    Logger.getLogger(AbstractInjection.class.getName()).log(Level.SEVERE, null, ex);
                } 

            }
        }
    }
}
