
package br.com.post.util;

import org.easycassandra.persistence.EasyCassandraManager;
import org.easycassandra.persistence.Persistence;

import br.com.post.model.Post;
import br.com.post.service.RandomService;
import br.com.post.service.SequencialService;
import br.com.post.service.ServiceClient;

import com.google.inject.Provides;



/**
 *
 * @author otavio
 */
public class ServiceModule extends com.google.inject.AbstractModule {

    @Override
    protected void configure() {

    	  bind(ServiceClient.class).annotatedWith(Sequencial.class).to(SequencialService.class);
    	  bind(ServiceClient.class).annotatedWith(Random.class).to(RandomService.class);
    }
 
    @Provides @Random
    public Persistence getRandomPersistence(){
        initEasyCassandra();
       return EasyCassandraManager.getPersistenceRandom("guice");
        
    }

    private void initEasyCassandra() {
        EasyCassandraManager.getPersistence("javabahia", "localhost", 9160);
        EasyCassandraManager.getPersistence("javabahia", "node2", 9160);
        EasyCassandraManager.getPersistence("javabahia", "node3", 9160);
        EasyCassandraManager.addFamilyObject(Post.class);
    }
    
    @Provides @Sequencial
    public Persistence getSequencialPersistence(){
    
        initEasyCassandra();
       return EasyCassandraManager.getPersistenceSequencial("guice");
        
    }
    
    
}
